ASUS MultiAntenna Service Release Notes
===============================================
v3.1.3 (2021.04.12)
---------
* Fixed issues that config set may be wrongly evaluated on certain systems.
* Added more error codes for config downloader.

v3.1.2 (2021.03.30)
---------
* Fixed issues that may cause failures on unloading bluetooth driver.

v3.1.1 (2021.01.28)
---------
* Fixed issues that potentially cause BSOD in certain systems.

v3.1.0 (2020.12.28)
---------
* Added supporting for MTK wireless network interface cards.

v3.0.5 (2020.12.07)
---------
* Fixed continuous retrying while Performance Counter path is unavailable.
* Changed behaviours while Performance Counter is unavailable at initialization and running.
* Changed implementation of interruptable sleeps using Windows API.
* Changed behaviour while system awakes from sleeping to fix potentially tampered GPIO status.

v3.0.4 (2020.11.26)
---------
* Added support for SPDT switches by setting OFF to both -1.


v3.0.3 (2020.11.10)
---------
* Limit auto download retry times to 20.
* Added test token support. (Place magic.txt along with AsusMultiAntennaSvc.exe to enable.)

v3.0.2 (2020.09.28)
---------
* Added auto downloading configuration from server.
* Added auto restart service after process be killed.

v3.0.1 (2020.09.07)
---------
* Changed weights of config set to solve Bluetooth related issues.
* Changes error handling machanism for certain models.
* Fix continuous scanning while bluetooth devices are discovered nearby.
* Fix log mechanism when log buffer is full.

v3.0.0 (2019.12.31)
---------
* Bandwidth value > RSSI value > bit order determinator as default.
* Optional exponential waiting.
* Optional MCS & RSSI Monitor
* Partial Model Name Matching
* Partial handling -95dBm Entries

v2.0.4 (2019.02.27)
---------
* Fix bug that wrongly selected default mode while other better candidates available.

v2.0.3 (2018.09.03)
---------
* Fix bug that not triggering RSSI scanner after AC connected.

v2.0.2 (2018.08.20)
---------
* Fix bug that not reporting mode of mapped switch.
* Fix bug that not setting default mode in case of AC lost.

v2.0.1 (2018.08.14)
---------
* Fix bug that not triggering RSSI scanning after re-connected to wifi.
* Add writing config version into registry.

v2.0.0 (2018.07.02)
---------
* Introduce multi-config per situation and flexible GPIO Config.
* Situations: 2.4G, 5G, BT devices connected, Close Lid.
* Log entries moved to "Applications and Services Log - ASUS - Services - MultiAntenna - Operation".

v1.0.4 (2018.06.22)
---------
* Fix installer bug that doesn't install service as system-wide.

v1.0.3 (2018.06.21)
---------
* Change log level of certain log enteies.

v1.0.2 (2018.05.14)
---------
* Fix a bug of wrongly enumerated network interfaces.
* Fix a bug in mode determinator on duplicated rssi values.

v1.0.1 (2018.04.13)
---------
* Change Service PS RSSI to PM RSSI convert method from max() to average.
* Add configuration cipher.
 * Renamed to Conf.bin
 * Use attached **ASMAConfigCodec** to decrypt/encrypt.
* Per-Model Configuration **MUST** add prefix in section name, e.g. [Settings.GL504GM]

v1.0.0 (2018.04.10)
---------
* Initial release.